<?php

// This include file is used to display site access, bans, and warnings.
// As coded, it is called from the admin/leftbanner.php file of a TNG revision 5.1.4/6.0.0 installation
// This file should be placed in the admin folder of the TNG installation directory
// 
// 
// Customizations:
//   - check the user configurable values below
// 
// Revision 1.3, Thu Sep 29, 2006
// Brian McFadyen

// The following parameter is user configurable, it must match the check_access.php variable of the same name

	$access_table = "site_access";   // The TNG table containing the access data,created by check_access.php

include("../begin.php");
include("../genlib.php");
tng_db_connect($database_host,$database_name,$database_username,$database_password) or exit;

$passwd = "view";
$pass = "noview";
if(isset($HTTP_GET_VARS[pass])) $pass = $HTTP_GET_VARS[pass];
if(isset($HTTP_POST_VARS[pass])) $pass = $HTTP_POST_VARS[pass];
if($pass != $passwd) {
	include($cms[tngpath] . "checklogin.php");
}
?>

<link href='../genstyle.css' rel='stylesheet'>
<br /><p class="header">Site Access and Hammer Stats</p>

<?php
$sorttype="none";
$deltype="none";
$range="none";
$do_note="none";
$add_note="none";
$note="none";
$create_note=0;
$remhost = getenv( "REMOTE_HOST" );
if( !$remhost ) {
	$remhost = $HTTP_SERVER_VARS['REMOTE_HOST'];
	if( !$remhost ) {
		$remip = getenv("REMOTE_ADDR");
		if( !$remip ) $remip = $HTTP_SERVER_VARS['REMOTE_ADDR'];
		$remhost = @gethostbyaddr( $remip );
		if( !$remhost ) $remhost = $remip;
	}
}



if(isset($HTTP_POST_VARS[sort])) $sorttype = $HTTP_POST_VARS[sort];
if(isset($HTTP_POST_VARS[del])) $deltype = $HTTP_POST_VARS[del];
if(isset($HTTP_POST_VARS[range])) $range = $HTTP_POST_VARS[range];
if(isset($HTTP_POST_VARS[do_note])) $do_note = $HTTP_POST_VARS[do_note];
if(isset($HTTP_POST_VARS[add_note])) $add_note = $HTTP_POST_VARS[add_note];
if(isset($HTTP_POST_VARS[note])) $note = nl2br(strip_tags(stripslashes($HTTP_POST_VARS[note])));

if($deltype !== "none" && $range !== "none") {
	if ($deltype === "date"){
		$db_query="DELETE from $access_table where hit_time < $range";
	} elseif ($deltype === "page"){
		$db_query="DELETE from $access_table where hit_count < $range";
	} elseif ($deltype === "host"){
		$db_query="DELETE from $access_table where host_name = \"$range\"";
	}
  if($pass != $passwd) $result = mysql_query($db_query);
}

if($do_note !== "none"){
	$db_query="SELECT hit_note_request from $access_table where host_name=\"$do_note\"";
	$result = mysql_query($db_query);
  $answer = mysql_fetch_assoc($result);
  if($answer[hit_note_request] <= 0){
  	$create_note = 1;
	} else {
		$db_query="UPDATE $access_table set hit_note_request=\"0\" where host_name=\"$do_note\"";
 		if($pass != $passwd || $do_note == $remhost) $result = mysql_query($db_query);
 	}
}

if($add_note !== "none"){
	$db_query="UPDATE $access_table set hit_note_request=\"4\", hit_note=\"$note\" where host_name=\"$add_note\"";
 	if($pass != $passwd || $add_note == $remhost) $result = mysql_query($db_query);
}


$db_query="SELECT * from $access_table order by hit_ban DESC,hit_warn DESC,total_rip DESC,hit_count DESC";

if($sorttype === "addr"){
	$db_query="SELECT INET_ATON(host_ip) as bin_ip, host_ip, host_name, hit_time, hit_count, total_rip, hit_warn, hit_ban, hit_refer from $access_table order by bin_ip, hit_ban DESC,hit_warn DESC,total_rip DESC,hit_count DESC";
} elseif ($sorttype === "host"){
	$db_query="SELECT * from $access_table order by host_name,hit_time DESC,hit_ban DESC,hit_warn DESC,total_rip DESC,hit_count DESC";
} elseif ($sorttype === "date"){
	$db_query="SELECT * from $access_table order by hit_time DESC,hit_ban DESC,hit_warn DESC,total_rip DESC,hit_count DESC";
} elseif ($sorttype === "page"){
	$db_query="SELECT * from $access_table order by hit_count DESC, hit_ban DESC,hit_warn DESC,total_rip DESC";
}

$result = mysql_query($db_query);
?>
<style type="text/css">
.abc {
	font-size: 100%;
	color: #006600
	 }
.refsty {
	width: 200;
	word-wrap;
	break-word;
	}
</style>

<br/>
<div align="left">
	<span class="normal">
	<table cellpadding=5 border=1 class="abc">
    <caption align="left">
    	Stats related to regular and fast page access.  Includes the number of times a site was warned, and number of times it was banned.<br>
			Use the numbered button to request a comment to that user IP.
    	<?php 
    		if($deltype !== "none" ){
    			echo "<font color=red><br /><br />The Delete Arrows in the cells are used to <b>
    			permanently delete</b> all times or page counts below the cell selected,<br />
    			or the specific cell in the case of Hosts.</font><br />";
    		}
    	?>
    </caption>
<thead>
	<tr>
		<th>Host IP Address</th>
		<th>Host Name</th>
		<th>&nbsp;&nbsp;&nbsp;Time&nbsp;&nbsp;&nbsp;</th>
		<th align=center>Page hits</th>
		<th>Fast Pages</th>
		<th>Warns</th>
		<th>Bans</th>
		<th align=left class="refsty">Referer</th>
	</tr>
	<tr>
	<th>
		<form action="<?php print($PHP_SELF);?>" method="POST">
			<input type="hidden" name="sort" value="addr">
			<input type="hidden" name="pass" value="<?php echo $pass; ?>">
			<input type="submit" value="sort">
		</form>
	</th>
	<th>
		<?php if ($sorttype === "host" && $pass !== $passwd){
			echo "<table><tr><td>";
		} ?>
		<form action="<?php print($PHP_SELF);?>" method="POST">
			<input type="hidden" name="sort" value="host">
			<input type="hidden" name="pass" value="<?php echo $pass; ?>">
			<input type="submit" value="sort">
		</form>
		<?php if ($sorttype === "host" && $pass !== $passwd){ ?>
		</td><td><form action="<?php print($PHP_SELF);?>" method="POST">
			<input type="hidden" name="del" value="host">
			<input type="hidden" name="sort" value="host">
			<input type="hidden" name="pass" value="<?php echo $pass; ?>">
			<input type="submit" value="del">
		</form>
		</td></tr></table>
		<?php } ?>
	</th>
	<th>
		<?php if ($sorttype === "date" && $pass !== $passwd){
			echo "<table><tr><td>";
		} ?>
		<form action="<?php print($PHP_SELF);?>" method="POST">
			<input type="hidden" name="sort" value="date">
			<input type="hidden" name="pass" value="<?php echo $pass; ?>">
			<input type="submit" value="sort">
		</form>
		<?php if ($sorttype === "date" && $pass !== $passwd){ ?>
		</td><td><form action="<?php print($PHP_SELF);?>" method="POST">
			<input type="hidden" name="del" value="date">
			<input type="hidden" name="sort" value="date">
			<input type="hidden" name="pass" value="<?php echo $pass; ?>">
			<input type="submit" value="del">
		</form>
		</td></tr></table>
		<?php } ?>
	</th>
	<th>
		<?php if ($sorttype === "page" && $pass !== $passwd){
			echo "<table><tr><td>";
		} ?>
		<form action="<?php print($PHP_SELF);?>" method="POST">
			<input type="hidden" name="sort" value="page">
			<input type="hidden" name="pass" value="<?php echo $pass; ?>">
			<input type="submit" value="sort">
		</form>
		<?php if ($sorttype === "page" && $pass !== $passwd){ ?>
		</td><td><form action="<?php print($PHP_SELF);?>" method="POST">
			<input type="hidden" name="del" value="page">
			<input type="hidden" name="sort" value="page">
			<input type="hidden" name="pass" value="<?php echo $pass; ?>">
			<input type="submit" value="del">
		</form>
		</td></tr></table>
		<?php } ?>
	</th>
	<th>
		&nbsp;
	</th>
	<th>
		&nbsp;
	</th>
	<th>
		&nbsp;
	</th>
	<th>
		&nbsp;
	</th>
</tr>
</thead>

<?php
$the_host_label = "none";
while( $row = mysql_fetch_assoc($result))
{
	echo "<tr>";
	echo "<td>$row[host_ip]</td>";
	echo "<td>";
//	if ($deltype === "date" || $pass !== $passwd){
		echo "<table class=\"abc\"><colgroup width=\"100%\"><tr><td>";
//	}
	if ($row[hit_note_request] != 0){
		echo "<font color=\"red\"><b>";
	}
	echo "<a name=\"$row[host_name]\">$row[host_name]</a>";
	if ($row[hit_note_request] != 0){
		echo "</b></font>";
	}
//	if($pass !== $passwd){ 
			echo "</td><td><form action=" . $PHP_SELF . "#$the_host_label method=\"POST\">";
			if($create_note && $do_note == $row[host_name]) {
				echo "<input type=\"hidden\" name=\"add_note\" value=\"$row[host_name]\">";
				echo "<input type=\"submit\" value=\"Add\">";
				echo "<textarea name=\"note\" cols=40 rows=10 maxlength=250>" .
				"I've noticed your investigation into common ancestors. " .
				"I would appreciate any info you would be willing to share.\n" .
				"Please contact me at $emailaddr\n" .
				"Please feel free to continue browsing.\n" .
				"$dbowner</textarea>";
			} else {
				echo "<input type=\"hidden\" name=\"do_note\" value=\"$row[host_name]\">";
				echo "<input type=\"submit\" value=\"$row[hit_note_request]\">";
			}
			echo "<input type=\"hidden\" name=\"pass\" value=\"$pass\">";
			echo "<input type=\"hidden\" name=\"sort\" value=\"$sorttype\">";
			echo "</form>";
//	}
	if ($deltype === "host" && $pass !== $passwd){ ?>
		</td><td><form action="<?php echo $PHP_SELF . "#$the_host_label";?>" method="POST">
			<input type="hidden" name="del" value="host">
			<input type="hidden" name="range" value="<?php echo $row[host_name];?>">
			<input type="hidden" name="sort" value="host">
			<input type="hidden" name="pass" value="<?php echo $pass; ?>">
			<input type="submit" value="<">
		</form>
<?php }
//	if($pass !== $passwd){
		echo "</td></tr></table>";
//	}
	echo "</td>";
		
	echo "<td align=center>";
	if ($deltype === "date" && $pass !== $passwd){
		echo "<table class=\"abc\"><colgroup width=\"100%\"></colgroup><tr><td>";
	}
	echo date("M-d",round($row[hit_time])) . "<br />" . date("g:ia",round($row[hit_time]));
	if ($deltype === "date" && $pass !== $passwd){ ?>
		</td><td><form action="<?php print($PHP_SELF);?>" method="POST">
			<input type="hidden" name="del" value="date">
			<input type="hidden" name="range" value="<?php echo $row[hit_time];?>">
			<input type="hidden" name="sort" value="date">
			<input type="hidden" name="pass" value="<?php echo $pass; ?>">
			<input type="submit" value="v">
		</form>
		</td></tr></table>
<?php }
	echo "</td>";
	echo "<td align=center>";
	if ($deltype === "page" && $pass !== $passwd){
		echo "<table class=\"abc\"><colgroup width=\"100%\"></colgroup><tr><td>";
	}
	echo "$row[hit_count]";
	if ($deltype === "page" && $pass !== $passwd){ ?>
		</td><td><form action="<?php print($PHP_SELF);?>" method="POST">
			<input type="hidden" name="del" value="page">
			<input type="hidden" name="range" value="<?php echo $row[hit_count];?>">
			<input type="hidden" name="sort" value="page">
			<input type="hidden" name="pass" value="<?php echo $pass; ?>">
			<input type="submit" value="v">
		</form>
		</td></tr></table>
<?php }
	echo "</td>";
	echo "<td align=center>$row[total_rip]</td>";
	echo "<td align=center>$row[hit_warn]</td>";
	echo "<td align=center>$row[hit_ban]</td>";
	echo "<td class=\"refsty\">$row[hit_refer]&nbsp;</td>";
	echo "</tr>\n";
	$the_host_label = $row[host_name];
}
echo "</table><br/><br/>";
mysql_free_result($result);
?>
	</span>
</div>
<?php
	tng_footer( "" );
?>
